// DO NOT EDIT
// This file is automatically generated by the varlink rust generator

use failure::{Backtrace, Context, Fail};
use serde_json;
use std::io::BufRead;
use std::sync::{Arc, RwLock};
use varlink::{self, CallTrait};

#[derive(Serialize, Deserialize, Debug, PartialEq, Clone)]
pub struct GetInfo_Reply {
 pub vendor: String,
 pub product: String,
 pub version: String,
 pub url: String,
 pub interfaces: Vec<String>,
}

impl varlink::VarlinkReply for GetInfo_Reply {}

#[derive(Serialize, Deserialize, Debug, PartialEq, Clone)]
pub struct GetInfo_Args {
}

#[derive(Serialize, Deserialize, Debug, PartialEq, Clone)]
pub struct Resolve_Reply {
 pub address: String,
}

impl varlink::VarlinkReply for Resolve_Reply {}

#[derive(Serialize, Deserialize, Debug, PartialEq, Clone)]
pub struct Resolve_Args {
 pub interface: String,
}

#[derive(Serialize, Deserialize, Debug, PartialEq, Clone)]
pub struct InterfaceNotFound_Args {
 pub interface: String,
}

pub trait VarlinkCallError: varlink::CallTrait {
    fn reply_interface_not_found(&mut self, interface: String) -> varlink::Result<()> {
        self.reply_struct(varlink::Reply::error(
            "org.varlink.resolver.InterfaceNotFound",
            Some(serde_json::to_value(InterfaceNotFound_Args { interface })?),
        ))
    }
}

impl<'a> VarlinkCallError for varlink::Call<'a> {}


#[derive(Debug)]
pub struct Error {
    inner: Context<ErrorKind>,
}

#[derive(Clone, PartialEq, Debug, Fail)]
pub enum ErrorKind {
    #[fail(display = "IO error")]
    Io_Error(::std::io::ErrorKind),
    #[fail(display = "(De)Serialization Error")]
    SerdeJson_Error(serde_json::error::Category),
    #[fail(display = "Varlink Error")]
    Varlink_Error(varlink::ErrorKind),
    #[fail(display = "Unknown error reply: '{:#?}'", _0)]
    VarlinkReply_Error(varlink::Reply),
    #[fail(display = "org.varlink.resolver.InterfaceNotFound: {:#?}", _0)]
    InterfaceNotFound(Option<InterfaceNotFound_Args>),
}

impl Fail for Error {
    fn cause(&self) -> Option<&Fail> {
        self.inner.cause()
    }

    fn backtrace(&self) -> Option<&Backtrace> {
        self.inner.backtrace()
    }
}

impl ::std::fmt::Display for Error {
    fn fmt(&self, f: &mut ::std::fmt::Formatter) -> ::std::fmt::Result {
        ::std::fmt::Display::fmt(&self.inner, f)
    }
}

impl Error {
    #[allow(dead_code)]
    pub fn kind(&self) -> ErrorKind {
        self.inner.get_context().clone()
    }
}

impl From<ErrorKind> for Error {
    fn from(kind: ErrorKind) -> Error {
        Error {
            inner: Context::new(kind),
        }
    }
}

impl From<Context<ErrorKind>> for Error {
    fn from(inner: Context<ErrorKind>) -> Error {
        Error { inner }
    }
}

impl From<::std::io::Error> for Error {
    fn from(e: ::std::io::Error) -> Error {
        let kind = e.kind();
        e.context(ErrorKind::Io_Error(kind)).into()
    }
}

impl From<serde_json::Error> for Error {
    fn from(e: serde_json::Error) -> Error {
        let cat = e.classify();
        e.context(ErrorKind::SerdeJson_Error(cat)).into()
    }
}

#[allow(dead_code)]
pub type Result<T> = ::std::result::Result<T, Error>;

impl From<varlink::Error> for Error {
    fn from(e: varlink::Error) -> Self {
        let kind = e.kind();
        match kind {
            varlink::ErrorKind::Io(kind) => e.context(ErrorKind::Io_Error(kind)).into(),
            varlink::ErrorKind::SerdeJsonSer(cat) => e.context(ErrorKind::SerdeJson_Error(cat)).into(),
            kind => e.context(ErrorKind::Varlink_Error(kind)).into(),
        }
    }
}

impl From<varlink::Reply> for Error {
    fn from(e: varlink::Reply) -> Self {
        if varlink::Error::is_error(&e) {
            return varlink::Error::from(e).into();
        }

        match e {
            varlink::Reply {
                     error: Some(ref t), ..
                } if t == "org.varlink.resolver.InterfaceNotFound" =>
                {
                   match e {
                       varlink::Reply {
                           parameters: Some(p),
                           ..
                       } => match serde_json::from_value(p) {
                           Ok(v) => ErrorKind::InterfaceNotFound(v).into(),
                           Err(_) => ErrorKind::InterfaceNotFound(None).into(),
                       },
                       _ => ErrorKind::InterfaceNotFound(None).into(),
                   }
               }
            _ => ErrorKind::VarlinkReply_Error(e).into(),
        }
    }
}
pub trait Call_GetInfo: VarlinkCallError {
    fn reply(&mut self, vendor: String, product: String, version: String, url: String, interfaces: Vec<String>) -> varlink::Result<()> {
        self.reply_struct(GetInfo_Reply { vendor, product, version, url, interfaces }.into())
    }
}

impl<'a> Call_GetInfo for varlink::Call<'a> {}

pub trait Call_Resolve: VarlinkCallError {
    fn reply(&mut self, address: String) -> varlink::Result<()> {
        self.reply_struct(Resolve_Reply { address }.into())
    }
}

impl<'a> Call_Resolve for varlink::Call<'a> {}

pub trait VarlinkInterface {
    fn get_info(&self, call: &mut Call_GetInfo) -> varlink::Result<()>;
    fn resolve(&self, call: &mut Call_Resolve, interface: String) -> varlink::Result<()>;
    fn call_upgraded(&self, _call: &mut varlink::Call, _bufreader: &mut BufRead) ->
        varlink::Result<Vec<u8>> {
        Ok(Vec::new())
    }
}

pub trait VarlinkClientInterface {
    fn get_info(&mut self) -> varlink::MethodCall<GetInfo_Args, GetInfo_Reply, Error>;
    fn resolve(&mut self, interface: String) -> varlink::MethodCall<Resolve_Args, Resolve_Reply, Error>;
}

#[allow(dead_code)]
pub struct VarlinkClient {
    connection: Arc<RwLock<varlink::Connection>>,
}

impl VarlinkClient {
    #[allow(dead_code)]
    pub fn new(connection: Arc<RwLock<varlink::Connection>>) -> Self {
        VarlinkClient {
            connection,
        }
    }
}

impl VarlinkClientInterface for VarlinkClient {
    fn get_info(&mut self) -> varlink::MethodCall<GetInfo_Args, GetInfo_Reply, Error> {
            varlink::MethodCall::<GetInfo_Args, GetInfo_Reply, Error>::new(
            self.connection.clone(),
            "org.varlink.resolver.GetInfo",
            GetInfo_Args {  },
        )
    }
    fn resolve(&mut self, interface: String) -> varlink::MethodCall<Resolve_Args, Resolve_Reply, Error> {
            varlink::MethodCall::<Resolve_Args, Resolve_Reply, Error>::new(
            self.connection.clone(),
            "org.varlink.resolver.Resolve",
            Resolve_Args { interface },
        )
    }
}

#[allow(dead_code)]
pub struct VarlinkInterfaceProxy {
    inner: Box<VarlinkInterface + Send + Sync>,
}

#[allow(dead_code)]
pub fn new(inner: Box<VarlinkInterface + Send + Sync>) -> VarlinkInterfaceProxy {
    VarlinkInterfaceProxy { inner }
}

impl varlink::Interface for VarlinkInterfaceProxy {
    fn get_description(&self) -> &'static str {
        r#####################################"# Interface to resolve reverse-domain interface names to
# service adresses
interface org.varlink.resolver

# Get a list of all resolvable interfaces and information
# about the resolver's identity.
method GetInfo() -> (
  vendor: string,
  product: string,
  version: string,
  url: string,
  interfaces: []string
)

# Resolve an interface name to a registered varlink service address
method Resolve(interface: string) -> (address: string)

error InterfaceNotFound (interface: string)
"#####################################
    }

    fn get_name(&self) -> &'static str {
        "org.varlink.resolver"
    }

    fn call_upgraded(&self, call: &mut varlink::Call, bufreader: &mut BufRead) ->
        varlink::Result<Vec<u8>> {
        self.inner.call_upgraded(call, bufreader)
    }

    fn call(&self, call: &mut varlink::Call) -> varlink::Result<()> {
        let req = call.request.unwrap();
        match req.method.as_ref() {
            "org.varlink.resolver.GetInfo" => {
                self.inner.get_info(call as &mut Call_GetInfo)
            }
            "org.varlink.resolver.Resolve" => {
                if let Some(args) = req.parameters.clone() {
                    let args: Resolve_Args = match serde_json::from_value(args) {Ok(v) => v, Err(e) => { let es = format!("{}", e); let _ = call.reply_invalid_parameter(es.clone()); return Err(varlink::ErrorKind::SerdeJsonDe(es).into()); } };
                    self.inner.resolve(call as &mut Call_Resolve, args.interface)
                } else {
                    call.reply_invalid_parameter("parameters".into())
                }
            }

            m => {
                call.reply_method_not_found(String::from(m))
            }
        }
    }
}